Attribute VB_Name = "modMain"
Option Explicit

'History:
'   07.nov.2003 v1.0.3: First release
'   09.nov.2003 v1.0.4: Bug reported by DooGie. Names was changed to lowercase when read fron config-files. Fixed
'   12.nov.2003 v1.0.5: The "runtime error 340.... " has been corrected. It was experienced by people
'                       having nore than 10 Mods installed. Fixed
'                     : Someone reported a "Too many files..." error. This _must_ be due to cyclic execution of config-files. Fixed.
'   26.apr.2004 v2.0.0: Complete rewrite.
'                     : More colors.
'                     : Much simpler interface. No more typing "^" codes. Editing is done fully in color.
'                     : Now works even if Windows has been re-installed or if the SOF2 folder has been manually moved.
'                       This is a common problem.
'   12.jan.2005 v2.1.0: Once again you can work with different names for different mods.
'                     : It's now possible to paste a name containing colorcode (^) into the textfield.
'                     : You can always select the right SOF2 directory if you have moved the game or have multiple installation.
'   22.may.2007 v2.1.0: Sourcecode released to the public.



Public Const STRIP_CHAR = """"
Public Const CODE_CHAR = "^"
Public Const DEFAULT_NAME = "UnnamedPlayer"
'Public Const DEFAULT_COLOR = &H74C2A9  'RGB(169, 194, 116)
Public Const DEFAULT_CODE = "2"


Const BTHICKNESS_X = 1
Const BTHICKNESS_Y = 1

Type RGBCode
  lngRGB As Long
  strChar As String
  lngCodeOrder As Long
  lngColorOrder As Long
End Type

Private Type DRAWTEXTPARAMS
  cbSize As Long
  iTabLength As Long
  iLeftMargin As Long
  iRightMargin As Long
  uiLengthDrawn As Long
End Type
Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32.dll" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long

Public Type Modification
  mod_modname    As String
  mod_modpath    As String
  mod_playername As String
End Type

Public g_ModArray(1 To 30) As Modification
Public g_ModCount As Long

Public g_RGBArray(0 To 89) As RGBCode

Public g_LoadName As String  ' Name from config-files
Public g_ShownName As String  ' Mostly name from config-files
Public g_SaveName As String


Public g_BackColor As Long

Sub Main()

  InitCommonControlsXP

  g_BackColor = vbBlack

  SetupColorData

  Load frmMain

  SetupColorPalette

  SetupPlayerName

End Sub

Sub SetupPlayerName(Optional strMod As String = "")

  Dim strName As String
  Dim strPath As String

  g_LoadName = ScanForMods(strMod)
  If "" = g_LoadName Then
    g_LoadName = DEFAULT_NAME
  End If

  SetupInterface strGetSOF2Path

  frmMain.LoadEditorText
  frmMain.Show

  Load frmSplash

  frmSplash.Gradient

  SetBkMode frmSplash.hdc, TRANSPARENT
  frmSplash.Font.name = "Verdana"
  frmSplash.Font.Size = 42

  Dim lngPosX1 As Long
  Dim lngPosX2 As Long

  lngPosX1 = frmSplash.Width / Screen.TwipsPerPixelX
  lngPosX1 = lngPosX1 - frmSplash.TextWidth(strRemoveTags(g_ShownName))  ' Remember to set form-font to the one used for name !!!
  lngPosX1 = lngPosX1 / 2
  lngPosX2 = 60
  If lngPosX1 <= lngPosX2 Then lngPosX1 = lngPosX2

  RenderOutlinedText "Verdana", 48, 0, frmSplash.hdc, "^3Welcome", lngPosX2, 50, RGB(50, 50, 50), 2, 2, True
  RenderOutlinedText "Verdana", 42, 0, frmSplash.hdc, g_ShownName, lngPosX1, 100, RGB(50, 50, 50), 2, 2, True
  RenderOutlinedText "Verdana", 20, 0, frmSplash.hdc, "^3...to ^3i^.nfre^3q^.uent's ^3Name Editor v" & App.Major & "." & App.Minor & "." & App.Revision, 185, 185, RGB(50, 50, 50), 1, 1, True

  frmSplash.ShowForm


  frmMain.rtbName.SelStart = Len(frmMain.rtbName.Text)
  frmMain.rtbName.SelLength = 0
  frmMain.rtbName.SetFocus

End Sub

Sub SetupInterface(strPath As String)
  With frmMain
    If strPath = "" Then
      .cmdReadName.Enabled = False
      .cmdWriteName.Enabled = False
      '      .mniBrowseForSOF.Enabled = True
      .lblStatusMsg(0).Caption = "SOF2 does not seem to be installed on this PC. Perhaps you've re-installed Windows or moved the SOF2-folder ?"
      .lblStatusMsg(1).Caption = "Select 'File->Browse for SOF2 folder...' to find where SOF2 is installed."
    Else
      .cmdReadName.Enabled = True
      .cmdWriteName.Enabled = True
      '      .mniBrowseForSOF.Enabled = False
      .lblStatusMsg(0).Caption = ""
      .lblStatusMsg(1).Caption = ""
    End If
  End With
End Sub


Sub SetStatus(Optional strMsg1 As String = "", Optional strMsg2 As String = "")
  If strMsg1 <> "#" Then
    frmMain.lblStatusMsg(0).Caption = strMsg1
    frmMain.lblStatusMsg(0).Refresh
  End If
  If strMsg2 <> "#" Then
    frmMain.lblStatusMsg(1).Caption = strMsg2
    frmMain.lblStatusMsg(1).Refresh
  End If
End Sub

Sub RenderCodedName()
  With frmMain
    .ObtainCodeText
    .lblCodeText.Caption = g_SaveName
    .picDraw1.Cls
    RenderOutlinedText "Ariel", 26, 0, .picDraw1.hdc, g_SaveName & " ^7is on ^$fire^7... ^37 ^7kills in a row!", 110, 50, RGB(10, 10, 10), BTHICKNESS_X, BTHICKNESS_Y, True
  End With
End Sub

''
'' Render a text with SOF2 colorcodes
''
Sub RenderOutlinedText(strFont As String, lngFontSize As Long, lngFontWidth As Long, lnghDC As Long, strText As String, lngX As Long, lngY As Long, lngOutlineRGB As Long, lngXOutline As Long, lngYOutline As Long, Optional blnBold As Boolean = False, Optional blnItalic As Boolean = False, Optional blnUnderlined As Boolean = False, Optional blnAntialiased As Boolean = False)

  Dim lngPos As Long
  Dim lngIdx As Long
  Dim lngRGB As Long
  Dim strChar As String
  Dim lngState As Long
  Dim lngPrintX As Long
  Dim lngPrintY As Long

  lngPos = 0
  lngState = 0
  lngPrintX = lngX
  lngPrintY = lngY

  lngRGB = g_RGBArray(FindColorFromCode(DEFAULT_CODE)).lngRGB

  Dim lngThisFont As Long
  Dim lngPrevFont As Long
  SetBkMode lnghDC, TRANSPARENT
  lngThisFont = CreateTheFont(strFont, lngFontSize, lngFontWidth, blnBold, blnItalic, blnUnderlined, blnAntialiased)
  lngPrevFont = SelectObject(lnghDC, lngThisFont)

  Do While lngPos < Len(strText)
    lngPos = lngPos + 1
    strChar = Mid(strText, lngPos, 1)

    If strChar = CODE_CHAR Then
      lngState = 1
    ElseIf lngState = 1 Then
      ' already found CODE_CHAR
      lngIdx = FindColorFromCode(strChar)
      If -1 = lngIdx Then
        ' Color does not exist
        Exit Sub
      End If
      lngRGB = g_RGBArray(lngIdx).lngRGB
      'lngState = 0
      'Exit Sub
      lngState = 2
    ElseIf lngState = 2 Then
      lngState = 0
    End If

    If lngState = 0 Then
      DrawOutlinedText lnghDC, strChar, lngPrintX, lngPrintY, lngOutlineRGB, lngRGB, lngXOutline, lngYOutline
      lngPrintX = lngPrintX + GetTextSize(lnghDC, strChar).Width
    End If

  Loop
  SelectObject lnghDC, lngPrevFont
  DeleteObject lngThisFont

End Sub

Sub DrawOutlinedText(lnghDC As Long, strText As String, lngX As Long, lngY As Long, lngOutlineRGB As Long, lngFillRGB As Long, lngXOutline As Long, lngYOutline As Long)
  Dim lngLen As Long
  Dim X As Long
  Dim Y As Long
  lngLen = Len(strText)
  SetTextColor lnghDC, lngOutlineRGB
  For X = -lngXOutline To lngXOutline
    For Y = -lngYOutline To lngYOutline
      If (X <> 0) And (Y <> 0) Then TextOut lnghDC, lngX + X, lngY + Y, strText, lngLen
    Next
  Next
  SetTextColor lnghDC, lngFillRGB
  TextOut lnghDC, lngX, lngY, strText, lngLen
End Sub

Sub DrawText(lnghDC As Long, strText As String, lngX As Long, lngY As Long, lngFillRGB As Long)
  Dim lngLen As Long
  lngLen = Len(strText)
  SetTextColor lnghDC, lngFillRGB
  TextOut lnghDC, lngX, lngY, strText, lngLen
End Sub

Function FindColorFromCode(strChar As String) As Long
  Dim lngIdx As Long
  FindColorFromCode = -1
  For lngIdx = LBound(g_RGBArray) To UBound(g_RGBArray)
    If strChar = g_RGBArray(lngIdx).strChar Then
      FindColorFromCode = lngIdx
      Exit Function
    End If
  Next
End Function

Function FindColorFromRGB(lngRGB As Long) As Long
  Dim lngIdx As Long
  FindColorFromRGB = -1
  For lngIdx = LBound(g_RGBArray) To UBound(g_RGBArray)
    If lngRGB = g_RGBArray(lngIdx).lngRGB Then
      FindColorFromRGB = lngIdx
      Exit Function
    End If
  Next
End Function


Sub SetupColorData()
  Dim lngIdx As Long
  lngIdx = -1

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 0
    .lngRGB = RGB(0, 0, 0)
    .strChar = "0"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 320
    .lngRGB = RGB(255, 25, 25)
    .strChar = "1"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 460
    .lngRGB = RGB(169, 194, 116)
    .strChar = "2"  ' Default color
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 970
    .lngRGB = RGB(255, 255, 0)
    .strChar = "3"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 140
    .lngRGB = RGB(76, 76, 255)
    .strChar = "4"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 805
    .lngRGB = RGB(0, 253, 253)
    .strChar = "5"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 850
    .lngRGB = RGB(255, 0, 255)
    .strChar = "6"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 1000
    .lngRGB = RGB(255, 255, 255)
    .strChar = "7"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 190
    .lngRGB = RGB(122, 0, 216)
    .strChar = "8"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 790
    .lngRGB = RGB(60, 220, 181)
    .strChar = "9"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 795
    .lngRGB = RGB(0, 243, 181)
    .strChar = "a"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 540
    .lngRGB = RGB(220, 144, 60)
    .strChar = "b"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 840
    .lngRGB = RGB(215, 67, 206)
    .strChar = "c"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 778
    .lngRGB = RGB(127, 172, 218)
    .strChar = "d"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 364
    .lngRGB = RGB(216, 0, 134)
    .strChar = "e"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 779
    .lngRGB = RGB(112, 196, 206)
    .strChar = "f"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 730
    .lngRGB = RGB(129, 242, 41)
    .strChar = "g"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 360
    .lngRGB = RGB(134, 0, 40)
    .strChar = "h"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 170
    .lngRGB = RGB(37, 74, 173)
    .strChar = "i"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 680
    .lngRGB = RGB(74, 216, 0)
    .strChar = "j"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 440
    .lngRGB = RGB(206, 178, 129)
    .strChar = "k"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 783
    .lngRGB = RGB(144, 196, 242)
    .strChar = "l"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 810
    .lngRGB = RGB(189, 37, 182)
    .strChar = "m"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 738
    .lngRGB = RGB(78, 127, 50)
    .strChar = "n"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 390
    .lngRGB = RGB(175, 107, 112)
    .strChar = "o"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 740
    .lngRGB = RGB(36, 148, 107)
    .strChar = "p"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 400
    .lngRGB = RGB(175, 149, 148)
    .strChar = "q"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 820
    .lngRGB = RGB(182, 83, 178)
    .strChar = "r"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 70
    .lngRGB = RGB(50, 0, 34)
    .strChar = "s"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 350
    .lngRGB = RGB(122, 0, 40)
    .strChar = "t"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 160
    .lngRGB = RGB(60, 36, 181)
    .strChar = "u"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 670
    .lngRGB = RGB(13, 215, 67)
    .strChar = "v"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 30
    .lngRGB = RGB(0, 0, 1)
    .strChar = "w"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 60
    .lngRGB = RGB(0, 13, 41)
    .strChar = "x"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 745
    .lngRGB = RGB(14, 144, 196)
    .strChar = "y"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 509
    .lngRGB = RGB(178, 129, 50)
    .strChar = "z"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 120
    .lngRGB = RGB(74, 0, 239)
    .strChar = "A"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 675
    .lngRGB = RGB(60, 220, 41)
    .strChar = "B"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 330
    .lngRGB = RGB(237, 81, 36)
    .strChar = "C"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 93
    .lngRGB = RGB(50, 78, 127)
    .strChar = "D"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 732
    .lngRGB = RGB(108, 175, 40)
    .strChar = "E"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 60
    .lngRGB = RGB(0, 36, 112)
    .strChar = "F"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 734
    .lngRGB = RGB(72, 170, 37)
    .strChar = "G"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 375
    .lngRGB = RGB(149, 108, 129)
    .strChar = "H"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 780
    .lngRGB = RGB(78, 196, 220)
    .strChar = "I"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 420
    .lngRGB = RGB(148, 175, 149)
    .strChar = "J"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 660
    .lngRGB = RGB(173, 219, 129)
    .strChar = "K"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 505
    .lngRGB = RGB(178, 122, 216)
    .strChar = "L"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 736
    .lngRGB = RGB(0, 216, 122)
    .strChar = "M"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 530
    .lngRGB = RGB(209, 137, 0)
    .strChar = "N"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 508
    .lngRGB = RGB(181, 189, 242)
    .strChar = "O"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 700
    .lngRGB = RGB(0, 248, 0)
    .strChar = "P"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 370
    .lngRGB = RGB(243, 75, 189)
    .strChar = "Q"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 130
    .lngRGB = RGB(41, 60, 220)
    .strChar = "R"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 710
    .lngRGB = RGB(67, 242, 41)
    .strChar = "S"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 340
    .lngRGB = RGB(206, 78, 60)
    .strChar = "T"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 180
    .lngRGB = RGB(144, 67, 242)
    .strChar = "U"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 785
    .lngRGB = RGB(123, 200, 173)
    .strChar = "V"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 200
    .lngRGB = RGB(134, 0, 182)
    .strChar = "W"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 755
    .lngRGB = RGB(37, 180, 171)
    .strChar = "X"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 720
    .lngRGB = RGB(134, 215, 0)
    .strChar = "Y"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 507
    .lngRGB = RGB(175, 149, 220)
    .strChar = "Z"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 10
    .lngRGB = RGB(0, 0, 0)
    .strChar = "!"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 20
    .lngRGB = RGB(0, 0, 0)
    .strChar = "#"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 300
    .lngRGB = RGB(255, 0, 0)
    .strChar = "$"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 110
    .lngRGB = RGB(0, 0, 255)  ' ????
    .strChar = "%"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 100
    .lngRGB = RGB(0, 0, 255)
    .strChar = "&"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 860
    .lngRGB = RGB(250, 0, 250)
    .strChar = "("
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 806
    .lngRGB = RGB(0, 255, 255)
    .strChar = ")"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 980
    .lngRGB = RGB(236, 236, 236)
    .strChar = "*"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 410
    .lngRGB = RGB(183, 183, 183)
    .strChar = "+"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 80
    .lngRGB = RGB(63, 63, 63)
    .strChar = "-"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 380
    .lngRGB = RGB(126, 126, 126)
    .strChar = ","
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 150
    .lngRGB = RGB(93, 66, 184)
    .strChar = "."
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 362
    .lngRGB = RGB(179, 68, 111)
    .strChar = "\"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 70
    .lngRGB = RGB(50, 0, 101)  ''
    .strChar = "/"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 807
    .lngRGB = RGB(0, 255, 255)
    .strChar = "<"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 760
    .lngRGB = RGB(37, 175, 167)
    .strChar = ">"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 770
    .lngRGB = RGB(59, 172, 146)
    .strChar = "["
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 775
    .lngRGB = RGB(37, 182, 149)
    .strChar = "]"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 299
    .lngRGB = RGB(189, 14, 0)
    .strChar = "{"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 90
    .lngRGB = RGB(37, 73, 82)
    .strChar = "}"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 470
    .lngRGB = RGB(243, 178, 127)
    .strChar = ":"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 476
    .lngRGB = RGB(105, 171, 142)
    .strChar = "="
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 640
    .lngRGB = RGB(133, 215, 78)
    .strChar = "?"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 520
    .lngRGB = RGB(198, 129, 0)
    .strChar = "@"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 310
    .lngRGB = RGB(255, 0, 0)
    .strChar = "_"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 990
    .lngRGB = RGB(244, 244, 244)
    .strChar = "'"
  End With

  '  g_RGBArray(88).lngRGB = RGB(255, 0, 0) ' ????
  '  g_RGBArray(88).strChar = "`"

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 650
    .lngRGB = RGB(122, 219, 74)
    .strChar = "|"
  End With

  lngIdx = lngIdx + 1
  With g_RGBArray(lngIdx)
    .lngCodeOrder = lngIdx
    .lngColorOrder = 510
    .lngRGB = RGB(198, 129, 0)  ' ????
    .strChar = "~"
  End With

End Sub

Sub SetupColorPalette()

  With frmMain
    Dim lngThisFont As Long
    Dim lngPrevFont As Long
    Dim lngPrevMode As Long
    Dim lngIdx      As Long
    '    Dim udtHSL      As HSL
    '    Dim udtHSV      As HSV

    lngThisFont = CreateTheFont("Verdana", 13, 0)
    lngPrevFont = SelectObject(.picColors.hdc, lngThisFont)
    lngPrevMode = SetBkMode(.picColors.hdc, TRANSPARENT)

    Dim redpart As Long, greenpart As Long, bluepart As Long
    Dim xpos As Long, ypos As Long, xsize As Long, ysize As Long
    Dim row As Long, col As Long
    Const COLORROWS = 18
    Const COLORCOLS = 5
    Const XSLACK = 3
    Const YSLACK = 3
    xsize = (frmMain.picColors.Width - 10 - (XSLACK * (COLORCOLS - 1))) / COLORCOLS + 1
    ysize = (frmMain.picColors.Height - 25 - (XSLACK * (COLORROWS - 1))) / COLORROWS + 1
    lngIdx = -1
    ypos = 0
    For row = 1 To COLORROWS
      xpos = 0
      For col = 1 To COLORCOLS
        lngIdx = lngIdx + 1
        If lngIdx <= UBound(g_RGBArray) Then
          With .lblColor(lngIdx)
            .Left = xpos
            .Top = ypos
            .Width = xsize + 1
            .Height = ysize + 1
            .BackColor = g_RGBArray(lngIdx).lngRGB
            '.Caption = CODE_CHAR & g_RGBArray(lngIdx).strChar
            SplitRGB g_RGBArray(lngIdx).lngRGB, redpart, greenpart, bluepart
            .ToolTipText = "The code for this color is : " & CODE_CHAR & g_RGBArray(lngIdx).strChar & " (RGB-value: " & CLng(redpart) & "," & CLng(greenpart) & "," & CLng(bluepart) & ")"
          End With

          .picColors.ForeColor = g_RGBArray(lngIdx).lngRGB
          .picColors.Line (xpos, ypos)-((xpos + xsize - 1), (ypos + ysize - 1)), , BF
          DrawText .picColors.hdc, CODE_CHAR & g_RGBArray(lngIdx).strChar, xpos + 9, ypos + 4, ClearRGB(g_RGBArray(lngIdx).lngRGB)

          xpos = xpos + xsize + XSLACK
        End If
      Next
      ypos = ypos + ysize + YSLACK
    Next

    SetBkMode .picColors.hdc, lngPrevMode
    SelectObject .picColors.hdc, lngPrevFont
    DeleteObject lngThisFont
    .picColors.Refresh

  End With

End Sub

Function ClearRGB(lngRGB As Long) As Long
  Dim R As Long, G As Long, B As Long
  SplitRGB lngRGB, R, G, B
  If (R + G + B) > (3 * 128) Then
    ClearRGB = RGB(0, 0, 0)
  Else
    ClearRGB = RGB(255, 255, 255)
  End If
End Function


Function InverseRGB(lngRGB As Long) As Long
  Dim R As Long, G As Long, B As Long
  SplitRGB lngRGB, R, G, B
  R = (Not R) And 255
  G = (Not G) And 255
  B = (Not B) And 255
  InverseRGB = RGB(R, G, B)
End Function


Sub SplitRGB(lngRGB As Long, ByRef Red As Long, ByRef Green As Long, ByRef Blue As Long)
  Red = (lngRGB And &HFF&)
  Green = (lngRGB And &HFF00&) / &H100
  Blue = (lngRGB And &HFF0000) / &H10000
End Sub

Function strRemoveTags(strName As String)
  Dim strTmp As String
  Dim lngIdx As Long
  strTmp = strName
  lngIdx = 0
  For lngIdx = 1 To Len(strTmp) - 1
    If CODE_CHAR = Mid(strTmp, lngIdx, 1) Then
      Mid(strTmp, lngIdx + 1, 1) = STRIP_CHAR
    End If
  Next
  strTmp = Replace(strTmp, CODE_CHAR, "")
  strTmp = Replace(strTmp, STRIP_CHAR, "")
  strRemoveTags = strTmp
End Function

Function strCleanupTags(strName As String)
  Dim strTmp As String
  Dim lngIdx As Long
  Dim lngPos As Long
  Dim lngState As Long
  strTmp = strName
  lngIdx = 0

  strTmp = Replace(strTmp, "^^^^", CODE_CHAR)
  strTmp = Replace(strTmp, "^^^", CODE_CHAR)
  strTmp = Replace(strTmp, "^^", CODE_CHAR)

  For lngIdx = 1 To Len(strTmp) - 1
    If lngState = 0 Then
      If CODE_CHAR = Mid(strTmp, lngIdx, 1) Then
        lngPos = lngIdx
        lngState = 1
      End If
    ElseIf lngState = 1 Then
      If CODE_CHAR = Mid(strTmp, lngIdx, 1) Then
        Mid(strTmp, lngPos, 1) = STRIP_CHAR
        lngPos = lngIdx
        lngState = 1
      Else
        lngState = 2
      End If
    ElseIf lngState = 2 Then
      If CODE_CHAR = Mid(strTmp, lngIdx, 1) Then
        Mid(strTmp, lngPos, 1) = STRIP_CHAR
        Mid(strTmp, lngPos + 1, 1) = STRIP_CHAR
        lngPos = lngIdx
        lngState = 1
      Else
        lngState = 0
      End If
    End If
  Next
  strTmp = Replace(strTmp, STRIP_CHAR, "")
  '  strTmp = Replace(strTmp, "^'", "^3")
  '  strTmp = Replace(strTmp, "^(", "^6")
  '  strTmp = Replace(strTmp, "^)", "^5")
  strCleanupTags = strTmp

End Function


Private Function CreateTheFont(strName As String, lngSizeY As Long, lngSizeX As Long, Optional blnBold As Boolean = False, Optional blnItalic As Boolean = False, Optional blnUnderlined As Boolean = False, Optional blnAntialiased As Boolean = False, Optional lngRotation As Long = 0) As Long
  On Error Resume Next
  Dim plf As LOGFONT, i As Long
  Dim FontName As String
  FontName = strName
  FontName = FontName + String(32 - Len(FontName), 0)
  For i = 1 To 32
    plf.lfFaceName(i) = Asc(Mid$(FontName, i, 1))
  Next
  'Height
  plf.lfHeight = lngSizeY
  plf.lfWidth = lngSizeX
  'Bold ,Underline ,Strikeout ,Italic
  If blnBold Then plf.lfWeight = 700
  If blnItalic Then plf.lfItalic = 1
  If blnUnderlined Then plf.lfUnderline = 1
  '  plf.lfStrikeOut = 1
  'Anti Aliasing
  plf.lfQuality = ANTIALIASED_QUALITY
  'plf.lfQuality = NONANTIALIASED_QUALITY
  If lngRotation <> 0 Then plf.lfEscapement = lngRotation  ' * 10
  CreateTheFont = CreateFontIndirect(plf)
End Function

Function strGetSOF2Path() As String
  Dim objReg As clsRegistry
  Dim strPath As String
  Set objReg = New clsRegistry
  objReg.hkey = HKEY_LOCAL_MACHINE
  objReg.KeyRoot = "SOFTWARE\Activision"
  objReg.Subkey = "Soldier of Fortune II - Double Helix"
  strPath = objReg.GetRegistryValue("InstallPath")
  If strPath = "" Then
    '    Beep
    '    MsgBox "SOF2 does not seem to be installed on this computer !", vbOKOnly
    strGetSOF2Path = ""
    Exit Function
  End If
  strGetSOF2Path = strAddPathSlash(strPath)
End Function

Sub strSetSOF2Path(strPath As String)
  Dim objReg As clsRegistry
  Set objReg = New clsRegistry
  objReg.hkey = HKEY_LOCAL_MACHINE
  objReg.KeyRoot = "SOFTWARE\Activision"
  objReg.Subkey = "Soldier of Fortune II - Double Helix"
  objReg.SetRegistryValue "InstallPath", strPath, REG_SZ
  objReg.SetRegistryValue "PatchPath", strPath, REG_SZ
  objReg.SetRegistryValue "InstallEXEPath", strAddPathSlash(strPath) & "Sof2.exe", REG_SZ
End Sub

Function strSOF2MPPath() As String
  Dim strPath As String
  strPath = strGetSOF2Path
  If strPath <> "" Then
    strSOF2MPPath = strPath & "base\mp\"
  End If
End Function

Function ScanForMods(Optional strMod As String = "") As String
  Dim strPath            As String
  Dim strList            As String
  Dim strName            As String
  Dim strTmpName         As String
  Dim strFoundName       As String
  Dim strFoundFile       As String
  Dim strArray()         As String
  Dim lngIdx As Long

  ScanForMods = ""

  strPath = strGetSOF2Path
  If strPath = "" Then Exit Function

  ScanConfigForName strArray(), strPath & "base\mp\", strFoundName, strFoundFile

  g_ModCount = 1
  g_ModArray(g_ModCount).mod_modname = "SOF2 (standard MP)"
  g_ModArray(g_ModCount).mod_modpath = strPath & "base\mp\"
  g_ModArray(g_ModCount).mod_playername = strFoundName

  strName = Dir(strPath, vbDirectory)
  Do While strName <> ""
    If strName <> "." And strName <> ".." Then
      If (GetAttr(strPath & strName) And vbDirectory) = vbDirectory Then
        If blnFileExists(strPath & strName & "\sof2mp.cfg") Then
          If g_ModCount < 23 Then  ' Max number of mods
            g_ModCount = g_ModCount + 1
            ScanConfigForName strArray(), strPath & strName & "\", strTmpName, strFoundFile
            g_ModArray(g_ModCount).mod_modname = strName
            g_ModArray(g_ModCount).mod_modpath = strPath & strName & "\"
            g_ModArray(g_ModCount).mod_playername = strTmpName
          Else
            MsgBox "Too many Mods. Current maximum is 24. Please contact me to get a version that can handle more than that !", vbOKOnly
            Exit Do
          End If
        End If
      End If
    End If
    strName = Dir
  Loop

  ScanForMods = strFoundName

  If strMod <> "" Then
    ' Find specific name
    For lngIdx = 1 To g_ModCount
      If g_ModArray(lngIdx).mod_modname = strMod Then
        ScanConfigForName strArray(), g_ModArray(lngIdx).mod_modpath, strFoundName, strFoundFile
        Exit For
      End If
    Next
  End If

  If strFoundName <> "" Then
    ScanForMods = strFoundName
  End If

End Function

Sub ScanConfigForName(ByRef strArray() As String, strPath As String, ByRef strFoundName As String, ByRef strFoundFile As String, Optional blnGUI As Boolean = False)

  strFoundName = ""
  strFoundFile = ""

  If strPath = "" Then Exit Sub

  If InStr(1, strPath, "base\mp\", vbTextCompare) Then
    ScanConfigFile strArray, strPath, strPath & "sof2mp.cfg", strFoundName, strFoundFile, blnGUI
    ScanConfigFile strArray, strPath, strPath & "autoexec.cfg", strFoundName, strFoundFile, blnGUI
  Else
    ScanConfigFile strArray, strPath, strPath & "autoexec.cfg", strFoundName, strFoundFile, blnGUI
    ScanConfigFile strArray, strPath, strPath & "sof2mp.cfg", strFoundName, strFoundFile, blnGUI
  End If

End Sub

''
'' Recursively scan configfiles
''
Sub ScanConfigFile(ByRef strArray() As String, strPath As String, strFile As String, ByRef strFoundName As String, ByRef strFoundFile As String, Optional blnGUI As Boolean = False)

  Dim strTmp             As String
  Dim lngTmp             As Long
  Dim lngIdx             As Long
  Dim strLine            As String
  Dim strlcLine          As String
  Dim blnFound           As Boolean
  Dim strMsg1            As String
  Dim strMsg2            As String
  Dim lngFileNo          As Long

  If blnFileExists(strFile) Then


    ' Check the array. Has this file already been parsed ??
    blnFound = False
    lngTmp = 0
    If IsBounded(strArray) Then
      lngTmp = UBound(strArray)
      For lngIdx = 1 To lngTmp
        If strFile = strArray(lngIdx) Then
          blnFound = True
          Exit For
        End If
      Next
    End If

    If Not blnFound Then
      ReDim Preserve strArray(1 To lngTmp + 1) As String
      strArray(UBound(strArray)) = strFile

      blnFound = False

      lngFileNo = FreeFile()
      Open strFile For Input As #lngFileNo
      strMsg1 = "Scanning " & strFile
      If blnGUI Then SetStatus strMsg1, strMsg2
      Do While Not EOF(lngFileNo)
        Line Input #lngFileNo, strLine
        strlcLine = LCase(strLine)
        If Left(strlcLine, 1) = "/" Then
        Else
          lngTmp = InStr(1, strlcLine, "exec ")
          If lngTmp > 0 Then
            strTmp = Mid(strlcLine, lngTmp + Len("exec "))
            For lngIdx = 1 To Len(strTmp)
              If InStr(1, Mid(strTmp, lngIdx, 1), ";,:") > 0 Then
                strTmp = Left(strTmp, lngIdx - 1)
                Exit For
              End If
            Next
            strTmp = Replace(strTmp, """", "")
            If strTmp <> "" Then
              If InStr(1, strTmp, ":\") = 0 Then
                strTmp = strPath & strTmp
              End If
              strMsg1 = strMsg1 & " - found config-file " & strTmp
              If blnGUI Then SetStatus strMsg1, strMsg2
              ScanConfigFile strArray, strPath, strTmp, strFoundName, strFoundFile, blnGUI
            End If
          ElseIf InStr(1, strlcLine, " name ") Then
            blnFound = False
            If Not blnFound Then
              strTmp = "set name "
              lngTmp = InStr(1, strlcLine, strTmp)
              If lngTmp > 0 Then
                blnFound = True
              End If
            End If
            If Not blnFound Then
              strTmp = "seta name "
              lngTmp = InStr(1, strlcLine, strTmp)
              If lngTmp > 0 Then
                blnFound = True
              End If
            End If
            If blnFound Then
              strTmp = Mid(strLine, lngTmp + Len(strTmp))  ' Not the lowercase text !
              For lngIdx = 1 To Len(strTmp)
                If InStr(1, Mid(strTmp, lngIdx, 1), ";,:") > 0 Then
                  strTmp = Left(strTmp, lngIdx - 1)
                  Exit For
                End If
              Next
              strTmp = Replace(strTmp, """", "")
              If strTmp <> "" Then
                strFoundName = strCleanupTags(strTmp)
                strFoundFile = strFile
                strMsg2 = "Name found : " & strTmp
                If blnGUI Then SetStatus strMsg1, strMsg2
              End If
            End If
          End If
        End If
      Loop
      Close #lngFileNo
    Else
      Beep
      ' File about to be parsed twice ! Skip !
    End If
  End If
  If blnGUI Then SetStatus "", ""

End Sub

Private Function IsBounded(myVariant As Variant) As Boolean
  Dim myUpperBound As Long
  On Error GoTo IsBoundedError
  If IsArray(myVariant) Then
    'if array is not bounded, this will generate an error
    myUpperBound = UBound(myVariant)
  End If
  IsBounded = True
  Exit Function
IsBoundedError:
  IsBounded = False
End Function

''
'' Render a colortext in a RichTextBox
''
Sub CodeTextToRTB(ByRef rtb As RichTextBox, strText As String)

  Dim lngPos As Long
  Dim lngIdx As Long
  Dim lngRGB As Long
  Dim strChar As String
  Dim strPart As String
  Dim lngState As Long

  rtb.Tag = "BUSY"

  lngRGB = g_RGBArray(FindColorFromCode(DEFAULT_CODE)).lngRGB  ' Default

  lngPos = 0
  lngState = 0

  rtb.Text = ""
  rtb.SelStart = 0

  Do While lngPos < Len(strText)
    lngPos = lngPos + 1
    strChar = Mid(strText, lngPos, 1)

    If strChar = CODE_CHAR Then
      If "" <> strPart Then
        rtb.SelColor = lngRGB
        rtb.SelText = strPart
        strPart = ""
      End If
      lngState = 1
    ElseIf lngState = 1 Then
      ' already found CODE_CHAR
      lngIdx = FindColorFromCode(strChar)
      If -1 = lngIdx Then
        ' Color does not exist
        'Exit Sub
      Else
        lngRGB = g_RGBArray(lngIdx).lngRGB
      End If
      lngState = 0
    Else
      strPart = strPart & strChar
    End If
  Loop

  If "" <> strPart Then
    rtb.SelColor = lngRGB
    rtb.SelText = strPart
    strPart = ""
  End If

  rtb.Tag = ""

End Sub

''
''
Function CodeTextFromRTB(ByRef rtb As RichTextBox) As String

  Dim lngPos As Long
  Dim lngIdx As Long
  Dim lngRGB As Long
  Dim strCode As String
  Dim strChar As String
  Dim strBuf As String
  Dim strText As String
  Dim lngState As Long
  Dim lngBackupSelStart As Long
  Dim lngBackupSelLength As Long

  lngPos = 0
  lngState = 0

  lngRGB = g_RGBArray(FindColorFromCode(DEFAULT_CODE)).lngRGB  ' Default

  lngBackupSelStart = rtb.SelStart
  lngBackupSelLength = rtb.SelLength

  strText = ""
  strBuf = rtb.Text
  rtb.SelStart = 0

  Do While lngPos < Len(strBuf)
    rtb.SelStart = lngPos
    rtb.SelLength = 1
    If lngRGB <> rtb.SelColor Then
      lngRGB = rtb.SelColor
      lngIdx = FindColorFromRGB(lngRGB)
      If -1 = lngIdx Then
        ' Color does not exist
        'Exit Sub
      Else
        strCode = CODE_CHAR & g_RGBArray(lngIdx).strChar
        strText = strText & strCode
      End If
    End If
    lngPos = lngPos + 1
    strText = strText & Mid(strBuf, lngPos, 1)
  Loop

  rtb.SelStart = lngBackupSelStart
  rtb.SelLength = lngBackupSelLength

  CodeTextFromRTB = strText
End Function

Function SelectModIndex(strTitle As String, strAccept As String, blnSave As Boolean, objParent As Object) As Long
  Dim lngIdx As Long
  Dim sglPos As Single
  ScanForMods
  Load frmModSelect
  frmModSelect.Caption = strTitle
  frmModSelect.cmdOK.Caption = strAccept
  SelectModIndex = -1
  sglPos = frmModSelect.chkMod(0).Top

  For lngIdx = 1 To g_ModCount
    Load frmModSelect.chkMod(lngIdx)
    Load frmModSelect.lblPlayername(lngIdx)
    sglPos = sglPos + frmModSelect.chkMod(0).Height
    frmModSelect.chkMod(lngIdx).Caption = g_ModArray(lngIdx).mod_modname
    frmModSelect.chkMod(lngIdx).Top = sglPos
    frmModSelect.chkMod(lngIdx).Visible = True
    frmModSelect.lblPlayername(lngIdx).Caption = g_ModArray(lngIdx).mod_playername
    frmModSelect.lblPlayername(lngIdx).Top = sglPos + (frmModSelect.lblPlayername(0).Top - frmModSelect.chkMod(0).Top)
    frmModSelect.lblPlayername(lngIdx).Visible = True
  Next
  If blnSave Then
    frmModSelect.chkMod(0).Caption = "All the mods"
    frmModSelect.chkMod(0).Visible = True
    frmModSelect.chkMod(0).Value = True
  Else
    frmModSelect.chkMod(0).Visible = False
    frmModSelect.chkMod(1).Value = True
  End If
  frmModSelect.lblPlayername(0).Font.Bold = True
  frmModSelect.Line1(0).Y1 = sglPos + 890
  frmModSelect.Line1(0).Y2 = sglPos + 890
  frmModSelect.Line1(1).Y1 = sglPos + 850
  frmModSelect.Line1(1).Y2 = sglPos + 850
  frmModSelect.Height = sglPos + 2000
  frmModSelect.cmdOK.Top = sglPos + 1050
  frmModSelect.cmdCancel.Top = sglPos + 1050
  frmModSelect.Show vbModal, objParent
  If frmModSelect.lngResult = 1 Then
    For lngIdx = 0 To g_ModCount  ' From 0 !
      If frmModSelect.chkMod(lngIdx).Value Then
        SelectModIndex = lngIdx
        Exit For
      End If
    Next
  End If
  Unload frmModSelect
End Function

