Attribute VB_Name = "modSupport"
Option Explicit

Public Type HSL
  Hue         As Long
  Saturation  As Long
  Luminance   As Long
End Type

Public Type HSV
  Hue         As Long
  Saturation  As Long
  Value       As Long
End Type

Function blnFileExists(strFile As String) As Boolean
  Dim strTmp As String
  Dim lngFileNo As Long
  blnFileExists = False

  lngFileNo = FreeFile
  On Error GoTo nofile
  Open strFile For Input As #lngFileNo
  Close #lngFileNo
  blnFileExists = True
  Exit Function
nofile:
  blnFileExists = False
End Function

''
'' Tilfj "\" til path hvis det mangler
''
Function strAddPathSlash(strPath As String) As String
  strAddPathSlash = strPath
  If Not Right$(strAddPathSlash, 1) = "\" Then
    strAddPathSlash = strAddPathSlash & "\"
  End If
End Function

''
'' Fjern "\" fra path
''
Function strRemPathSlash(strPath As String) As String
  strRemPathSlash = strPath
  If Right$(strRemPathSlash, 1) = "\" Then
    strRemPathSlash = Left$(strRemPathSlash, Len(strRemPathSlash) - 1)
  End If
End Function

''
'' Returner filnavn delen fra en path\filnavn
''
Function strFileNamePart(strPathname As String) As String
  '   Returns the filename from a path/filename string
  Dim lngIdx                            As Long
  Dim lnglength                         As Long

  lnglength = Len(strPathname)
  For lngIdx = lnglength To 1 Step -1
    If Mid$(strPathname, lngIdx, 1) = "\" Then
      strFileNamePart = Mid$(strPathname, lngIdx + 1)
      Exit Function
    End If
  Next
  strFileNamePart = strPathname
End Function

''
'' Returner path delen fra en path\filnavn
''
Function strPathNamePart(strPathname As String) As String
  '   Returns the path from a path/filename string
  Dim lngIdx                            As Long
  Dim lnglength                         As Long

  lnglength = Len(strPathname)
  For lngIdx = lnglength To 1 Step -1
    If Mid$(strPathname, lngIdx, 1) = "\" Then
      strPathNamePart = Mid$(strPathname, 1, lngIdx)
      Exit Function
    End If
  Next
  ' Ingen "/" ! Det m vre et rent filnavn uden sti.
  strPathNamePart = ""
End Function

''
'' Returner yyy af et filnavn xxxx.yyy
''
Function strNameExtPart(strFileName) As String
  '   Returns the filename from a path/filename string
  Dim lnglength                         As Long

  strNameExtPart = ""
  lnglength = Len(strFileName)
  If lnglength > 4 Then
    If Mid$(strFileName, lnglength - 3, 1) = "." Then
      strNameExtPart = Right$(strFileName, 3)
    End If
  End If

End Function

''
'' Returner xxxx af et filnavn xxxx.yyy
''
Function strNameNamePart(strFileName As String) As String
  '   Returns the filename from a path/filename string
  Dim lnglength                         As Long

  strNameNamePart = strFileName
  lnglength = Len(strFileName)
  If lnglength > 4 Then
    If Mid$(strFileName, lnglength - 3, 1) = "." Then
      strNameNamePart = Left$(strFileName, lnglength - 4)
    End If
  End If

End Function

Sub CloseAllForms(ByRef frmExcept As Form)
  Dim frm As Form
  For Each frm In Forms
    If Not frm Is frmExcept Then
      Unload frm
    End If
  Next
End Sub
'
'Public Function RGB2HSL(ByVal RGBValue As Long) As HSL
'  ' by Paul - wpsjr1@syix.com, 20011120
'  Dim R As Long, G As Long, B As Long
'  Dim lMax As Long, lMin As Long
'  Dim q As Single
'  Dim lDifference As Long
'  Static Lum(255) As Long
'  Static QTab(255) As Single
'  Static init As Long
'
'  If init = 0 Then
'    For init = 2 To 255  ' 0 and 1 are both 0
'      Lum(init) = init * 100 / 255
'    Next
'    For init = 1 To 255
'      QTab(init) = 60 / init
'    Next init
'  End If
'
'  R = RGBValue And &HFF
'  G = (RGBValue And &HFF00&) \ &H100&
'  B = (RGBValue And &HFF0000) \ &H10000
'
'  If R > G Then
'    lMax = R: lMin = G
'  Else
'    lMax = G: lMin = R
'  End If
'  If B > lMax Then
'    lMax = B
'  ElseIf B < lMin Then
'    lMin = B
'  End If
'
'  RGB2HSL.Luminance = Lum(lMax)
'
'  lDifference = lMax - lMin
'  If lDifference Then
'    ' do a 65K 2D lookup table here for more speed if needed
'    RGB2HSL.Saturation = (lDifference) * 100 / lMax
'    q = QTab(lDifference)
'    Select Case lMax
'      Case R
'        If B > G Then
'          RGB2HSL.Hue = q * (G - B) + 360
'        Else
'          RGB2HSL.Hue = q * (G - B)
'        End If
'      Case G
'        RGB2HSL.Hue = q * (B - R) + 120
'      Case B
'        RGB2HSL.Hue = q * (R - G) + 240
'    End Select
'  End If
'End Function

'Public Function RGB2HSL(ByVal RGBValue As Long) As HSL
'' by Branco Medeiros, 1999, branco@apis.com.br
''   (adapted from Java.awt.Color.java)
'' adjusted to our definition by Donald, 20011116
'  Dim lMin As Long, lMax As Long, lDelta As Long
'  Dim R As Long, G As Long, B As Long
'  Dim nTemp As Single
'
'  R = RGBValue And &HFF
'  G = (RGBValue And &HFF00&) \ &H100&
'  B = (RGBValue And &HFF0000) \ &H10000
'
'  lMax = IIf(R > G, IIf(R > B, R, B), IIf(G > B, G, B))
'  lMin = IIf(R < G, IIf(R < B, R, B), IIf(G < B, G, B))
'
'  RGB2HSL.Luminance = (lMax * 100) / 255
'
'  If lMax > 0 Then
'    lDelta = lMax - lMin
'    RGB2HSL.Saturation = (lDelta / lMax) * 100
'    If lDelta > 0 Then
'      If lMax = R Then
'        nTemp = (G - B) / lDelta
'      ElseIf lMax = G Then
'        nTemp = 2 + (B - R) / lDelta
'      Else
'        nTemp = 4 + (R - G) / lDelta
'      End If
'      RGB2HSL.Hue = nTemp * 60
'      If RGB2HSL.Hue < 0 Then
'        RGB2HSL.Hue = RGB2HSL.Hue + 360
'      End If
'    End If
'  End If
'
'End Function
'
'
'Public Function HSL2RGB(ByVal Hue As Long, ByVal Saturation As Long, ByVal Luminance As Long, Optional Validate As Boolean) As Long
'  ' by Donald (Sterex 1996), donald@xbeat.net, 20011119
'  Dim R As Long, G As Long, B As Long
'  Dim lMax As Long, lMid As Long, lMin As Long
'  Dim q As Single
'
'  If Validate Then ValidateHSL Hue, Saturation, Luminance
'
'  lMax = (Luminance * 255) / 100
'  lMin = (100 - Saturation) * lMax / 100
'  q = (lMax - lMin) / 60
'
'  Select Case Hue
'    Case 0 To 60
'      lMid = (Hue - 0) * q + lMin
'      R = lMax: G = lMid: B = lMin
'    Case 60 To 120
'      lMid = -(Hue - 120) * q + lMin
'      R = lMid: G = lMax: B = lMin
'    Case 120 To 180
'      lMid = (Hue - 120) * q + lMin
'      R = lMin: G = lMax: B = lMid
'    Case 180 To 240
'      lMid = -(Hue - 240) * q + lMin
'      R = lMin: G = lMid: B = lMax
'    Case 240 To 300
'      lMid = (Hue - 240) * q + lMin
'      R = lMid: G = lMin: B = lMax
'    Case 300 To 360
'      lMid = -(Hue - 360) * q + lMin
'      R = lMax: G = lMin: B = lMid
'  End Select
'
'  HSL2RGB = B * &H10000 + G * &H100& + R
'
'End Function
'
'Public Sub ValidateHSL(Hue As Long, Saturation As Long, Luminance As Long)
'  ' by Donald, donald@xbeat.net, 20011119
'
'  ' Hue: 0-360, wrapped around (Hue is a circle)
'  '   eg. -2 -> 358, 362 -> 2
'  If Hue < 0 Then
'    If Hue < -2147483520 Then  '5965232 * 360
'      Hue = (Hue + 2147483520) + 360
'    Else
'      Hue = (Hue + 2147483520)
'    End If
'  End If
'  Hue = Hue Mod 360
'
'  ' Saturation: 0-100, cut-off
'  '   eg. -2 -> 0, 120 -> 100
'  If Saturation < 0 Then
'    Saturation = 0
'  ElseIf Saturation > 100 Then
'    Saturation = 100
'  End If
'
'  ' Luminance: same as Saturation
'  If Luminance < 0 Then
'    Luminance = 0
'  ElseIf Luminance > 100 Then
'    Luminance = 100
'  End If
'
'  ''Debug.Print Hue, Saturation, Luminance
'End Sub



'RGBToHSV
'
'USES
'  Math,        // MaxValue
'  IEEE754,  // NaN, IsNaN
'  SysUtils;    // Exception
'
'TYPE
'  EColorError = CLASS(Exception);
'  TReal = DOUBLE;
'...
'// RGB, each 0 to 255, to HSV.
'// H = 0.0 to 360.0 (corresponding to 0..360.0 degrees around hexcone)
'// S = 0.0 (shade of gray) to 1.0 (pure color)
'// V = 0.0 (black) to 1.0 {white)
'
'// Based on C Code in "Computer Graphics -- Principles and Practice,"
'// Foley et al, 1996, p. 592.
'
'PROCEDURE RGBToHSV (CONST R,G,B: TReal; VAR H,S,V: TReal);
'  Var
'    Delta: TReal;
'    Min : TReal;
'BEGIN
'  Min := MinValue( [R, G, B] );    // USES Math
'  V := MaxValue( [R, G, B] );
'
'  Delta := V - Min;
'
'  // Calculate saturation: saturation is 0 if r, g and b are all 0
'  IF       V = 0.0
'  THEN S := 0
'  ELSE S := Delta / V;
'
'  IF       S = 0.0
'  THEN H := NaN    // Achromatic: When s = 0, h is undefined
'  ELSE BEGIN       // Chromatic
'    IF       R = V
'    THEN // between yellow and magenta [degrees]
'      H := 60.0 * (G - B) / Delta
'    Else
'      IF       G = V
'      THEN // between cyan and yellow
'        H := 120.0 + 60.0 * (B - R) / Delta
'      Else
'        IF       B = V
'        THEN // between magenta and cyan
'          H := 240.0 + 60.0 * (R - G) / Delta;
'
'    IF H < 0.0
'    THEN H := H + 360.0
'  End
'END {RGBtoHSV};
'
'
'
'HSVtoRGB
'
'// Based on C Code in "Computer Graphics -- Principles and Practice,"
'// Foley et al, 1996, p. 593.
'//
'// H = 0.0 to 360.0 (corresponding to 0..360 degrees around hexcone)
'// NaN (undefined) for S = 0
'// S = 0.0 (shade of gray) to 1.0 (pure color)
'// V = 0.0 (black) to 1.0 (white)
'
'PROCEDURE HSVtoRGB (CONST H,S,V: TReal; VAR R,G,B: TReal);
'  Var
'    f : TReal;
'    i : INTEGER;
'    hTemp: TReal; // since H is CONST parameter
'    p,q,t: TReal;
'BEGIN
'  IF       S = 0.0    // color is on black-and-white center line
'  THEN BEGIN
'    IF       IsNaN(H)
'    THEN BEGIN
'      R := V;           // achromatic: shades of gray
'      G := V;
'      B := V
'    End
'    ELSE RAISE EColorError.Create('HSVtoRGB: S = 0 and H has a value');
'  End
'
'  ELSE BEGIN // chromatic color
'    IF       H = 360.0         // 360 degrees same as 0 degrees
'    THEN hTemp := 0.0
'    ELSE hTemp := H;
'
'    hTemp := hTemp / 60;     // h is now IN [0,6)
'    i := TRUNC(hTemp);        // largest integer <= h
'    f := hTemp - i;                  // fractional part of h
'
'    p := V * (1.0 - S);
'    q := V * (1.0 - (S * f));
'    t := V * (1.0 - (S * (1.0 - f)));
'
'    CASE i OF
'      0: BEGIN R := V; G := t;  B := p  END;
'      1: BEGIN R := q; G := V; B := p  END;
'      2: BEGIN R := p; G := V; B := t   END;
'      3: BEGIN R := p; G := q; B := V  END;
'      4: BEGIN R := t;  G := p; B := V  END;
'      5: BEGIN R := V; G := p; B := q  END
'    End
'  End
'END {HSVtoRGB};
'
'
'Function zMin(A, B, C)
'  Dim Minnie
'  Minnie = A
'  If B < Minnie Then Minnie = B
'  If C < Minnie Then Minnie = C
'  zMin = Minnie
'End Function
'Function zMax(A, B, C)
'  Dim Maxie
'  Maxie = A
'  If B > Maxie Then Maxie = B
'  If C > Maxie Then Maxie = C
'  zMax = Maxie
'End Function
''Private Sub RGB2HSV(R, G, B, H, S, V)
''  aMin = zMin(R, G, B)
''  V = zMax(R, G, B)
''  Delta = V - aMin
''  If V = 0# Then S = 0# Else S = Delta / V
''  If S = 0 Then
''    H = -1
''  Else
''    If V = R Then H = 60# * (G - B) / Delta
''    If V = G Then H = 120# + 60# * (B - R) / Delta
''    If V = B Then H = 240# + 60# * (R - G) / Delta
''  End If
''End Sub
'
'Public Function RGB2HSV(ByVal RGBValue As Long) As HSV
'
'  '  Dim R As Long, G As Long, B As Long
'  Dim R As Double, G As Double, B As Double
'  Dim H As Double, s As Double, V As Double
'  Dim aMin As Double
'  Dim aMax As Double
'  Dim Delta As Double
'
'  R = RGBValue And &HFF
'  G = (RGBValue And &HFF00&) \ &H100&
'  B = (RGBValue And &HFF0000) \ &H10000
'
'  aMin = zMin(R, G, B)
'  aMax = zMax(R, G, B)
'  Delta = aMax - aMin
'  V = aMax
'  If aMax <> 0# Then
'    s = Delta / aMax
'  Else
'    s = 0#
'  End If
'
'  If s = 0# Then
'    H = 0
'    GoTo ExitFunc
'  End If
'
'  '  If R = aMax Then H = 0 + (G - B) / Delta
'  '  If G = aMax Then H = 2 + (B - R) / Delta
'  '  If B = aMax Then H = 4 + (R - G) / Delta
'  '  H = H * 60
'
'  If R = aMax Then H = 60# * (G - B) / Delta
'  If G = aMax Then H = 120# + 60# * (B - R) / Delta
'  If B = aMax Then H = 240# + 60# * (R - G) / Delta
'
'  If H < 0 Then H = H + 360
'
'ExitFunc:
'  RGB2HSV.Hue = H
'  RGB2HSV.Saturation = s
'  RGB2HSV.Value = V
'
'End Function
'
